#include "monopoly2.h"
#include <iostream>
#include <vector>
#include <bits/stdc++.h>
#include <queue>
using namespace std;
vector<pair<int, int>> ans;
const int maxn = 1005;
vector<int> subtree[maxn];
int parent[maxn];
queue<int> active;
bool taken[maxn];
pair<int, int> possible[maxn];
void print_debug(int N)
{
    cout << "parents" << endl;
    for (int i = 1; i <= N; i++)
    {
        cout << i << " " << parent[i] << endl;
    }
    cout << "subtree" << endl;
    for (int i = 1; i <= N; i++)
    {
        cout << i << " : ";
        for (auto v : subtree[i])
        {
            cout << v << " ";
        }
        cout << endl;
    }

}
vector<pair<int, int>> find_connections(int N)
{
    if (N == 1) return ans;
    ans.push_back(make_pair(1, 2));
    if (N == 2) return ans;
    for (int i = 3; i <= N; i++)
    {
        subtree[1].push_back(i);
    }
    active.push(2);
    parent[2] = 1;

    while (!active.empty())
    {
        vector<int> p;
        memset(taken, 0, sizeof(taken));
        while (!active.empty())
        {
            int u = active.front();
            active.pop();
            int par = parent[u];
            for (auto v : subtree[par])
            {
                if (!taken[v])
                {
                    p.push_back(v);
                    possible[v] = make_pair(par, u);
                    taken[v] = true;
                }
            }
            p.push_back(u);
            taken[u] = true;
            possible[u] = make_pair(-1, -1);
        }
        vector<int> query;
        for (int i = 1; i <= N; i++)
        {
            if (!taken[i])
            {
                query.push_back(i);
                possible[i] = make_pair(-1, -1);
            }
        }
        for (auto v : p)
        {
            query.push_back(v);
        }
        vector<bool> result = check(query);
        // //cout << "result: " << endl;
        // for (int i = 0; i < result.size(); i++)
        // {
        //     cout << result[i] << " ";
        // }
        // cout << endl;
        for (int i = 1; i <= N; i++)
        {
            subtree[i].clear();
        }
        for (int i = 0; i < query.size(); i++)
        {
            int u = query[i];
            if (possible[u].first == -1)
            {
                continue;
            }
            //cout << " &&&&& " << u << endl;
            if (result[i])
            {
                subtree[possible[u].second].push_back(u);
            }
            else
            {
                subtree[possible[u].first].push_back(u);
            }
        }
        //print_debug(N);
        //cout << "******************************************"<<endl;
        for (int i = 1; i <= N; i++)
        {
            sort(subtree[i].begin(), subtree[i].end());
            if (subtree[i].size() == 0)
                continue;
            int first = subtree[i][0];
            ans.push_back(make_pair(i, first));
            // delete first from subtree[i]
            subtree[i].erase(subtree[i].begin());
            if (subtree[i].size() != 0)
            {
                active.push(first);
                //cout << "ACTIVE: " << first << endl;
            }
            parent[first] = i;
        }

        //print_debug(N);
    }
    return ans;
}
