#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;
static const int MAXN=1000;
static const int MAXQ=1e8;
static const int base=15313,mod=57173;

enum status {
    OK=0,
    MANY_QUESTIONS=-1,
    INVALID_PERMUTATION=-2,
    WRONG_ANSWER=-3
};
static long long int hash1;
static int cnt;
static void finish (status s) {
    cout << hash1 << " " << int(s) ;
    if (s==OK) cout << " " << cnt ;
    cout << endl ;
    exit(0);
}

static int n;
static int seen[MAXN];
static int inds[MAXN];
static int parent[MAXN];
vector <bool> check (vector <int> p) {
    cnt++;
    if (cnt>MAXQ/n) finish(MANY_QUESTIONS);
    /*for (auto num : p) {
        cout << num << " ";
    }
    cout << endl ;*/
    if (p.size()!=n) finish(INVALID_PERMUTATION);
    for (int i=0; i<n; i++) {
        p[i]--;
        if ((p[i]<0)||(p[i]>=n)) finish(INVALID_PERMUTATION);
        if (seen[p[i]]==cnt) finish(INVALID_PERMUTATION);
        seen[p[i]]=cnt;
        inds[p[i]]=i;
    }
    vector <bool> result(n);
    result[inds[0]]=false;
    for (int i=1; i<n; i++) {
        int p=parent[i];
        if ((inds[p]>inds[i])||(result[inds[p]]==true)) result[inds[i]]=true;
    }
    return result;
}

extern vector <pair <int, int> > find_connections (int);
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int s;
    cin >> s ;
    cin >> n ;
    hash1*=base; hash1+=n;
    vector <pair <int, int> > tree;
    tree.reserve(n-1);
    for (int i=0; i<n-1; i++) {
        int x,y;
        cin >> x >> y ;
        hash1*=base; hash1+=x; hash1%=mod;
        hash1*=base; hash1+=y; hash1%=mod;
        tree.push_back({x, y});
        x--; y--;
        parent[y]=x;
    }
    auto found=find_connections(n);
    /*for (auto [x, y] : found) {
        cout << x << " " << y << endl ;
    }*/
    if (found.size()!=n-1) finish(WRONG_ANSWER);
    sort(tree.begin(),tree.end());
    sort(found.begin(),found.end());
    if (tree!=found) finish(WRONG_ANSWER);
    finish(OK);
    return 0;
}
