#include "testlib.h"
#include<iostream>
#include<string>
#include<vector>
#define MAXN 1000
using namespace std;
void error_message (const char message[]) {
    cerr << "Error - " << message << "\n";
    exit(0);
}
vector <int> a[MAXN+1];
int max1;
bool used[MAXN+1];
int dfs (int vr, int path) {
    ensuref(used[vr]==false,"cycle detected!");
    max1=max(max1,path);
    int cnt=1;
    for (auto to : a[vr]) {
        cnt+=dfs(to,path+1);
    }
    return cnt;
}
int parent[MAXN+1];
bool seen[MAXN+1];
int main (int argc, char* argv[]) {
    if (argc==1) error_message("the test validator needs arguments!\n");
    FILE* fin;
    fin=fopen(argv[1],"r");
    if (fin==NULL) error_message("wrong test name!");
    fclose(fin);
    freopen(argv[1],"r",stdin);
    registerValidation(argc,argv);

    int s=inf.readInt(0,5); inf.readEoln();
    int n=inf.readInt(1,MAXN,"N"); inf.readEoln();
    for (int i=0; i<n-1; i++) {
        int x=inf.readInt(1,n,"xi"); inf.readSpace();
        int y=inf.readInt(1,n,"yi"); inf.readEoln();
        ensuref(x!=y,"loop detected!");
        a[x].push_back(y);
        parent[y]=x;
    }
    inf.readEof();
    ensuref(dfs(1,0)==n,"unreachable vertices detected!");
    seen[1]=true;
    for (int i=2; i<=n; i++) {
        ensuref(seen[parent[i]]==true,"1...N not topological sort!");
        seen[i]=true;
    }
    cout << "Test is OK!\n";
    cout << n << " " << max1 << endl ;

    if ((s==1)&&(max1==n-1)) cout << "First subtask!\n";
    else if ((s==2)&&(n<=6)) cout << "Second subtask!\n";
    else if (s==3) {
        vector <int> bfs;
        bfs.reserve(n);
        bfs.push_back(1);
        int curr=0;
        for (;;) {
            if (curr==bfs.size()) break;
            int vr=bfs[curr++];
            for (auto to : a[vr]) {
                bfs.push_back(to);
            }
        }
        bool flag=true;
        for (int i=0; i<n; i++) {
            if (bfs[i]!=i+1) {
                flag=false;
                break;
            }
        }
        if (flag==true) cout << "Third subtask!\n";
        else cout << "? subtask! Should be " << s << "!\n";
    }
    else if ((s==4)&&(n<=300)) cout << "Fourth subtask!\n";
    else if ((s==5)&&(max1<=25)) cout << "Fifth subtask!\n";
    else cout << "? subtask! Should be " << s << "!\n";
    return 0;
}
